Index: LMDZ5/trunk/libf/phylmd/cosp/cosp_types.F90
===================================================================
--- LMDZ5/trunk/libf/phylmd/cosp/cosp_types.F90	(revision 2367)
+++ LMDZ5/trunk/libf/phylmd/cosp/cosp_types.F90	(revision 2428)
@@ -1375,5 +1364,280 @@
     y%cldlayer(iy(1):iy(2),:)    = x%cldlayer(ix(1):ix(2),:)
     y%parasolrefl(iy(1):iy(2),:) = x%parasolrefl(ix(1):ix(2),:)
+    y%lidarcldphase(iy(1):iy(2),:,:)  = x%lidarcldphase(ix(1):ix(2),:,:)
+    y%cldlayerphase(iy(1):iy(2),:,:)  = x%cldlayerphase(ix(1):ix(2),:,:)
+    y%lidarcldtmp(iy(1):iy(2),:,:)    = x%lidarcldtmp(ix(1):ix(2),:,:)
 END SUBROUTINE COSP_LIDARSTATS_CPSECTION
+!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
+!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
+!------------- PRINT SUBROUTINES --------------
+!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
+!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
+SUBROUTINE COSP_GRIDBOX_PRINT(x)
+    type(cosp_gridbox),intent(in) :: x
+
+    print *, '%%%%----- Information on COSP_GRIDBOX ------'
+    ! Scalars and dimensions
+    print *,  x%Npoints
+    print *,  x%Nlevels
+    print *,  x%Ncolumns
+    print *,  x%Nhydro
+    print *,  x%Nprmts_max_hydro
+    print *,  x%Naero
+    print *,  x%Nprmts_max_aero
+    print *,  x%Npoints_it
+    
+    ! Time [days]
+    print *,  x%time
+    
+    ! Radar ancillary info
+    print *,  x%radar_freq, &
+            x%k2
+    print *,  x%surface_radar, &
+              x%use_mie_tables, &
+              x%use_gas_abs, &
+              x%do_ray, &
+              x%melt_lay
+
+!               print *,  'shape(x%): ',shape(x%)
+ 
+!     type(class_param) ::  hp  ! structure used by radar simulator to store Ze and N scaling constants and other information
+!     type(mie)::  mt           ! structure used by radar simulator to store mie LUT information
+    print *,  x%nsizes
+    
+    ! Lidar
+    print *,  x%lidar_ice_type
+    
+    ! Radar
+    print *,  x%use_precipitation_fluxes
+    print *,  x%use_reff
+    
+    ! Geolocation (Npoints)
+    print *,  'shape(x%longitude): ',shape(x%longitude)
+    print *,  'shape(x%latitude): ',shape(x%latitude)
+    ! Gridbox information (Npoints,Nlevels)
+    print *,  'shape(x%zlev): ',shape(x%zlev)
+    print *,  'shape(x%zlev_half): ',shape(x%zlev_half)
+    print *,  'shape(x%dlev): ',shape(x%dlev)
+    print *,  'shape(x%p): ',shape(x%p)
+    print *,  'shape(x%ph): ',shape(x%ph)
+    print *,  'shape(x%T): ',shape(x%T)
+    print *,  'shape(x%q): ',shape(x%q)
+    print *,  'shape(x%sh): ',shape(x%sh)
+    print *,  'shape(x%dtau_s): ',shape(x%dtau_s)
+    print *,  'shape(x%dtau_c): ',shape(x%dtau_c)
+    print *,  'shape(x%dem_s): ',shape(x%dem_s)
+    print *,  'shape(x%dem_c): ',shape(x%dem_c)
+    print *,  'shape(x%mr_ozone): ',shape(x%mr_ozone)
+
+    ! Point information (Npoints)
+    print *,  'shape(x%land): ',shape(x%land)
+    print *,  'shape(x%psfc): ',shape(x%psfc)
+    print *,  'shape(x%sunlit): ',shape(x%sunlit)
+    print *,  'shape(x%skt): ',shape(x%skt)
+    print *,  'shape(x%u_wind): ',shape(x%u_wind)
+    print *,  'shape(x%v_wind): ',shape(x%v_wind)
+
+    ! TOTAL and CONV cloud fraction for SCOPS
+    print *,  'shape(x%tca): ',shape(x%tca)
+    print *,  'shape(x%cca): ',shape(x%cca)
+    ! Precipitation fluxes on model levels
+    print *,  'shape(x%rain_ls): ',shape(x%rain_ls)
+    print *,  'shape(x%rain_cv): ',shape(x%rain_cv)
+    print *,  'shape(x%snow_ls): ',shape(x%snow_ls)
+    print *,  'shape(x%snow_cv): ',shape(x%snow_cv)
+    print *,  'shape(x%grpl_ls): ',shape(x%grpl_ls)
+    ! Hydrometeors concentration and distribution parameters
+    print *,  'shape(x%mr_hydro): ',shape(x%mr_hydro)
+    print *,  'shape(x%dist_prmts_hydro): ',shape(x%dist_prmts_hydro)
+    ! Effective radius [m]. (Npoints,Nlevels,Nhydro)
+    print *,  'shape(x%Reff): ',shape(x%Reff)
+    print *,  'shape(x%Np): ',shape(x%Np)       ! added by roj with Quickbeam V3
+    ! Aerosols concentration and distribution parameters
+    print *,  'shape(x%conc_aero): ',shape(x%conc_aero)
+    print *,  'shape(x%dist_type_aero): ',shape(x%dist_type_aero)
+    print *,  'shape(x%dist_prmts_aero): ',shape(x%dist_prmts_aero)
+    ! ISCCP simulator inputs
+    print *, x%isccp_top_height
+    print *, x%isccp_top_height_direction
+    print *, x%isccp_overlap
+    print *, x%isccp_emsfc_lw
+  
+    ! RTTOV inputs/options
+    print *, x%plat
+    print *, x%sat
+    print *, x%inst
+    print *, x%Nchan
+    print *,  'shape(x%Ichan): ',x%Ichan
+    print *,  'shape(x%Surfem): ',x%Surfem
+    print *, x%ZenAng
+    print *, x%co2,x%ch4,x%n2o,x%co
+                
+END SUBROUTINE COSP_GRIDBOX_PRINT
+
+SUBROUTINE COSP_MISR_PRINT(x)
+    type(cosp_misr),intent(in) :: x
+
+    print *, '%%%%----- Information on COSP_MISR ------'
+                
+     ! Dimensions
+    print *, x%Npoints
+    print *, x%Ntau
+    print *, x%Nlevels
+
+     ! --- (npoints,ntau,nlevels)
+     !  the fraction of the model grid box covered by each of the MISR cloud types
+     print *,  'shape(x%fq_MISR): ',shape(x%fq_MISR)
+     
+     ! --- (npoints)
+     print *,  'shape(x%MISR_meanztop): ',shape(x%MISR_meanztop)
+     print *,  'shape(x%MISR_cldarea): ',shape(x%MISR_cldarea)
+     ! --- (npoints,nlevels)
+     print *,  'shape(x%MISR_dist_model_layertops): ',shape(x%MISR_dist_model_layertops)
+    
+END SUBROUTINE COSP_MISR_PRINT
+
+SUBROUTINE COSP_ISCCP_PRINT(x)
+    type(cosp_isccp),intent(in) :: x
+            
+    print *, x%Npoints
+    print *, x%Ncolumns
+    print *, x%Nlevels
+
+    print *, '%%%%----- Information on COSP_ISCCP ------'
+    
+     print *, 'shape(x%fq_isccp): ',shape(x%fq_isccp)
+     print *, 'shape(x%totalcldarea): ',shape(x%totalcldarea)
+     print *, 'shape(x%meantb): ',shape(x%meantb)
+     print *, 'shape(x%meantbclr): ',shape(x%meantbclr)
+     
+     print *, 'shape(x%meanptop): ',shape(x%meanptop)
+     print *, 'shape(x%meantaucld): ',shape(x%meantaucld)
+     print *, 'shape(x%meanalbedocld): ',shape(x%meanalbedocld)
+     print *, 'shape(x%boxtau): ',shape(x%boxtau)
+     print *, 'shape(x%boxptop): ',shape(x%boxptop)
+END SUBROUTINE COSP_ISCCP_PRINT
+
+SUBROUTINE COSP_VGRID_PRINT(x)
+    type(cosp_vgrid),intent(in) :: x
+            
+    print *, '%%%%----- Information on COSP_VGRID ------'
+    print *, x%use_vgrid
+    print *, x%csat_vgrid
+    print *, x%Npoints
+    print *, x%Ncolumns
+    print *, x%Nlevels
+    print *, x%Nlvgrid
+    ! Array with dimensions (Nlvgrid)
+    print *, 'shape(x%z): ',shape(x%z)
+    print *, 'shape(x%zl): ',shape(x%zl)
+    print *, 'shape(x%zu): ',shape(x%zu)
+    ! Array with dimensions (Nlevels)
+    print *, 'shape(x%mz): ',shape(x%mz)
+    print *, 'shape(x%mzl): ',shape(x%mzl)
+    print *, 'shape(x%mzu): ',shape(x%mzu)
+END SUBROUTINE COSP_VGRID_PRINT
+
+SUBROUTINE COSP_SGLIDAR_PRINT(x)
+    type(cosp_sglidar),intent(in) :: x
+            
+    print *, '%%%%----- Information on COSP_SGLIDAR ------'
+    ! Dimensions
+    print *, x%Npoints
+    print *, x%Ncolumns
+    print *, x%Nlevels
+    print *, x%Nhydro
+    print *, x%Nrefl
+    ! Arrays with dimensions (Npoints,Nlevels)
+    print *, 'shape(x%beta_mol): ',shape(x%beta_mol)
+    ! Arrays with dimensions (Npoints,Ncolumns,Nlevels)
+    print *, 'shape(x%beta_tot): ',shape(x%beta_tot)
+    print *, 'shape(x%tau_tot): ',shape(x%tau_tot)
+    ! Arrays with dimensions (Npoints,Ncolumns,Nrefl)
+    print *, 'shape(x%refl): ',shape(x%refl)
+END SUBROUTINE COSP_SGLIDAR_PRINT
+
+SUBROUTINE COSP_SGRADAR_PRINT(x)
+    type(cosp_sgradar),intent(in) :: x
+            
+    print *, '%%%%----- Information on COSP_SGRADAR ------'
+    print *, x%Npoints
+    print *, x%Ncolumns
+    print *, x%Nlevels
+    print *, x%Nhydro
+    ! output vertical levels: spaceborne radar -> from TOA to SURFACE
+    ! Arrays with dimensions (Npoints,Nlevels)
+    print *, 'shape(x%att_gas): ', shape(x%att_gas)
+    ! Arrays with dimensions (Npoints,Ncolumns,Nlevels)
+    print *, 'shape(x%Ze_tot): ', shape(x%Ze_tot)
+END SUBROUTINE COSP_SGRADAR_PRINT
+
+SUBROUTINE COSP_RADARSTATS_PRINT(x)
+    type(cosp_radarstats),intent(in) :: x
+            
+    print *, '%%%%----- Information on COSP_SGRADAR ------'
+    print *, x%Npoints
+    print *, x%Ncolumns
+    print *, x%Nlevels
+    print *, x%Nhydro
+    print *, 'shape(x%cfad_ze): ',shape(x%cfad_ze)
+    print *, 'shape(x%radar_lidar_tcc): ',shape(x%radar_lidar_tcc)
+    print *, 'shape(x%lidar_only_freq_cloud): ',shape(x%lidar_only_freq_cloud)
+END SUBROUTINE COSP_RADARSTATS_PRINT
+
+SUBROUTINE COSP_LIDARSTATS_PRINT(x)
+    type(cosp_lidarstats),intent(in) :: x
+            
+    print *, '%%%%----- Information on COSP_SGLIDAR ------'
+    print *, x%Npoints
+    print *, x%Ncolumns
+    print *, x%Nlevels
+    print *, x%Nhydro
+    print *, x%Nrefl
+    
+    ! Arrays with dimensions (SR_BINS)
+    print *, 'shape(x%srbval): ',shape(x%srbval)
+    ! Arrays with dimensions (Npoints,SR_BINS,Nlevels)
+    print *, 'shape(x%cfad_sr): ',shape(x%cfad_sr)
+    ! Arrays with dimensions (Npoints,Nlevels)
+    print *, 'shape(x%lidarcld): ',shape(x%lidarcld)
+    ! Arrays with dimensions (Npoints,LIDAR_NCAT)
+    print *, 'shape(x%cldlayer): ',shape(x%cldlayer)
+    ! Arrays with dimensions (Npoints,PARASOL_NREFL)
+    print *, 'shape(x%parasolrefl): ',shape(x%parasolrefl)
+     ! Arrays with dimensions (Npoints,Nlevels,Nphase)
+    print *, 'shape(x%lidarcldphase): ',shape(x%lidarcldphase)
+     ! Arrays with dimensions (Npoints,LIDAR_NCAT,Nphase)
+    print *, 'shape(x%cldlayerphase): ',shape(x%cldlayerphase)
+     ! Arrays with dimensions (Npoints,Ntemps,Nphase)
+    print *, 'shape(x%lidarcldphase): ',shape(x%lidarcldtmp)
+
+END SUBROUTINE COSP_LIDARSTATS_PRINT
+
+SUBROUTINE COSP_SUBGRID_PRINT(x)
+    type(cosp_subgrid),intent(in) :: x
+            
+    print *, '%%%%----- Information on COSP_SUBGRID ------'
+    print *, x%Npoints
+    print *, x%Ncolumns
+    print *, x%Nlevels
+    print *, x%Nhydro
+    
+    print *, 'shape(x%prec_frac): ',shape(x%prec_frac)
+    print *, 'shape(x%frac_out): ',shape(x%frac_out)
+END SUBROUTINE COSP_SUBGRID_PRINT
+
+SUBROUTINE COSP_SGHYDRO_PRINT(x)
+    type(cosp_sghydro),intent(in) :: x
+            
+    print *, '%%%%----- Information on COSP_SGHYDRO ------'
+    print *, x%Npoints
+    print *, x%Ncolumns
+    print *, x%Nlevels
+    print *, x%Nhydro
+    
+    print *, 'shape(x%mr_hydro): ',shape(x%mr_hydro)
+    print *, 'shape(x%Reff): ',shape(x%Reff)
+    print *, 'shape(x%Np): ',shape(x%Np)         ! added by roj with Quickbeam V3
+END SUBROUTINE COSP_SGHYDRO_PRINT
 
 END MODULE MOD_COSP_TYPES
Index: LMDZ5/trunk/libf/phylmd/cosp/cosp_utils.F90
===================================================================
--- LMDZ5/trunk/libf/phylmd/cosp/cosp_utils.F90	(revision 2367)
+++ LMDZ5/trunk/libf/phylmd/cosp/cosp_utils.F90	(revision 2428)
@@ -1,4 +1,6 @@
 ! (c) British Crown Copyright 2008, the Met Office.
 ! All rights reserved.
+! $Revision: 23 $, $Date: 2011-03-31 15:41:37 +0200 (jeu. 31 mars 2011) $
+! $URL: http://cfmip-obs-sim.googlecode.com/svn/stable/v1.4.0/cosp_utils.F90 $
 ! 
 ! Redistribution and use in source and binary forms, with or without modification, are permitted 
@@ -45,6 +47,6 @@
 !%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 SUBROUTINE COSP_PRECIP_MXRATIO(Npoints,Nlevels,Ncolumns,p,T,prec_frac,prec_type, &
-                          n_ax,n_bx,alpha_x,c_x,d_x,g_x,a_x,b_x,gamma1,gamma2, &
-                          flux,mxratio)
+                          n_ax,n_bx,alpha_x,c_x,d_x,g_x,a_x,b_x,gamma1,gamma2,gamma3,gamma4, &
+                          flux,mxratio,reff)
 
     ! Input arguments, (IN)
@@ -52,20 +54,21 @@
     real,intent(in),dimension(Npoints,Nlevels) :: p,T,flux
     real,intent(in),dimension(Npoints,Ncolumns,Nlevels) :: prec_frac
-    real,intent(in) :: n_ax,n_bx,alpha_x,c_x,d_x,g_x,a_x,b_x,gamma1,gamma2,prec_type
+    real,intent(in) :: n_ax,n_bx,alpha_x,c_x,d_x,g_x,a_x,b_x,gamma1,gamma2,gamma3,gamma4,prec_type
     ! Input arguments, (OUT)
     real,intent(out),dimension(Npoints,Ncolumns,Nlevels) :: mxratio
+    real,intent(inout),dimension(Npoints,Ncolumns,Nlevels) :: reff
     ! Local variables
     integer :: i,j,k
-    real :: sigma,one_over_xip1,xi,rho0,rho
+    real :: sigma,one_over_xip1,xi,rho0,rho,lambda_x,gamma_4_3_2,delta
     
     mxratio = 0.0
 
     if (n_ax >= 0.0) then ! N_ax is used to control which hydrometeors need to be computed
-        !gamma1  = gamma(alpha_x + b_x + d_x + 1.0)
-        !gamma2  = gamma(alpha_x + b_x + 1.0)
         xi      = d_x/(alpha_x + b_x - n_bx + 1.0)
         rho0    = 1.29
         sigma   = (gamma2/(gamma1*c_x))*(n_ax*a_x*gamma2)**xi
         one_over_xip1 = 1.0/(xi + 1.0)
+        gamma_4_3_2 = 0.5*gamma4/gamma3
+        delta = (alpha_x + b_x + d_x - n_bx + 1.0)
         
         do k=1,Nlevels
@@ -76,4 +79,9 @@
                         mxratio(i,j,k)=(flux(i,k)*((rho/rho0)**g_x)*sigma)**one_over_xip1
                         mxratio(i,j,k)=mxratio(i,j,k)/rho
+                        ! Compute effective radius
+                        if ((reff(i,j,k) <= 0.0).and.(flux(i,k) /= 0.0)) then
+                           lambda_x = (a_x*c_x*((rho0/rho)**g_x)*n_ax*gamma1/flux(i,k))**(1./delta)
+                           reff(i,j,k) = gamma_4_3_2/lambda_x
+                        endif
                     endif
                 enddo
Index: LMDZ5/trunk/libf/phylmd/cosp/dsd.F90
===================================================================
--- LMDZ5/trunk/libf/phylmd/cosp/dsd.F90	(revision 2367)
+++ LMDZ5/trunk/libf/phylmd/cosp/dsd.F90	(revision 2428)
@@ -1,4 +1,4 @@
-  subroutine dsd(Q,Re,D,N,nsizes,dtype,rho_a,tc, &
-             dmin,dmax,apm,bpm,rho_c,p1,p2,p3,fc,scaled)
+  subroutine dsd(Q,Re,Np,D,N,nsizes,dtype,rho_a,tk, &
+             dmin,dmax,apm,bpm,rho_c,p1,p2,p3)
   use array_lib
   use math_lib 
@@ -7,15 +7,26 @@
 ! Purpose:
 !   Create a discrete drop size distribution
-!   Part of QuickBeam v1.03 by John Haynes
+!
+!   Starting with Quickbeam V3, this routine now allows input of 
+!   both effective radius (Re) and total number concentration (Nt)
+!   Roj Marchand July 2010
+!
+!   The version in Quickbeam v.104 was modified to allow Re but not Nt 
+!   This is a significantly modified form for the version      
+!
+!   Originally Part of QuickBeam v1.03 by John Haynes
 !   http://reef.atmos.colostate.edu/haynes/radarsim
 !
 ! Inputs:
+!
 !   [Q]        hydrometeor mixing ratio (g/kg)
-!   [Re]       Optional Effective Radius (microns).  0 = use default.
-!   [D]        discrete drop sizes (um)
+!   [Re]       Optional Effective Radius (microns).  0 = use defaults (p1, p2, p3)
+!
+!   [D]        array of discrete drop sizes (um) where we desire to know the number concentraiton n(D).
 !   [nsizes]   number of elements of [D]
+!
 !   [dtype]    distribution type
 !   [rho_a]    ambient air density (kg m^-3)
-!   [tc]       temperature (C)
+!   [tk]       temperature (K)
 !   [dmin]     minimum size cutoff (um)
 !   [dmax]     maximum size cutoff (um)
@@ -24,6 +35,4 @@
 !
 ! Input/Output:
-!   [fc]       scaling factor for the distribution
-!   [scaled]   has this hydrometeor type been scaled?
 !   [apm]      a parameter for mass (kg m^[-bpm])
 !   [bmp]      b params for mass
@@ -41,18 +50,16 @@
 !   01/31/06  Port from IDL to Fortran 90
 !   07/07/06  Rewritten for variable DSD's
-!   10/02/06  Rewritten using scaling factors (Roger Marchand and JMH)
+!   10/02/06  Rewritten using scaling factors (Roger Marchand and JMH), Re added V1.04
+!   July 2020 "N Scale factors" (variable fc) removed (Roj Marchand).
  
 ! ----- INPUTS -----  
   
-  integer*4, intent(in) :: nsizes
+  integer, intent(in) :: nsizes
   integer, intent(in) :: dtype
-  real*8, intent(in) :: Q,D(nsizes),rho_a,tc,dmin,dmax, &
-    rho_c,p1,p2,p3
-    
-! ----- INPUT/OUTPUT -----
-
-  real*8, intent(inout) :: fc(nsizes),apm,bpm,Re
-  logical, intent(inout) :: scaled  
-    
+  real*8, intent(in)  :: Q,Re,Np,D(nsizes)
+  real*8, intent(in)  :: rho_a,tk,dmin,dmax,rho_c,p1,p2,p3
+    
+  real*8, intent(inout) :: apm,bpm  
+  
 ! ----- OUTPUTS -----
 
@@ -60,19 +67,22 @@
   
 ! ----- INTERNAL -----
-  
+ 
+   real*8 :: fc(nsizes)
+
   real*8 :: &
-  N0,D0,vu,np,dm,ld, &			! gamma, exponential variables
-  dmin_mm,dmax_mm,ahp,bhp, &		! power law variables
-  rg,log_sigma_g, &			! lognormal variables
-  rho_e					! particle density (kg m^-3)
+  N0,D0,vu,local_np,dm,ld, &            ! gamma, exponential variables
+  dmin_mm,dmax_mm,ahp,bhp, &        ! power law variables
+  rg,log_sigma_g, &         ! lognormal variables
+  rho_e                 ! particle density (kg m^-3)
   
   real*8 :: tmp1, tmp2
-  real*8 :: pi,rc
+  real*8 :: pi,rc,tc
 
   integer k,lidx,uidx
 
+  tc = tk - 273.15
   pi = acos(-1.0)
   
-! // if density is constant, store equivalent values for apm and bpm
+  ! // if density is constant, store equivalent values for apm and bpm
   if ((rho_c > 0) .and. (apm < 0)) then
     apm = (pi/6)*rho_c
@@ -80,4 +90,15 @@
   endif
   
+  ! will preferentially use Re input over Np.
+  ! if only Np given then calculate Re
+  ! if neigher than use other defaults (p1,p2,p3) following quickbeam documentation
+  if(Re==0 .and. Np>0) then
+    
+        call calc_Re(Q,Np,rho_a, &
+             dtype,dmin,dmax,apm,bpm,rho_c,p1,p2,p3, &
+             Re)
+  endif
+ 
+  
   select case(dtype)
   
@@ -85,63 +106,82 @@
 ! // modified gamma                                        !
 ! ---------------------------------------------------------!
-! :: N0 = total number concentration (m^-3)
-! :: np = fixed number concentration (kg^-1)
+! :: np = total number concentration
 ! :: D0 = characteristic diameter (um)
-! :: dm = mean diameter (um)
+! :: dm = mean diameter (um) - first moment over zeroth moment
 ! :: vu = distribution width parameter
 
   case(1)  
-    if (abs(p1+1) < 1E-8) then
-
-!     // D0, vu are given  
+  
+    if( abs(p3+2) < 1E-8) then
+  
+    if( Np>1E-30) then
+    
+        ! Morrison scheme with Martin 1994 shape parameter (NOTE: vu = pc +1)
+        ! fixed Roj. Dec. 2010 -- after comment by S. Mcfarlane
+        vu = (1/(0.2714 + 0.00057145*Np*rho_a*1E-6))**2.0 ! units of Nt = Np*rhoa = #/cm^3
+    else
+        print *, 'Error: Must specify a value for Np in each volume', &
+             ' with Morrison/Martin Scheme.'
+            stop    
+    endif
+    
+    elseif (abs(p3+1) > 1E-8) then
+
+      ! vu is fixed in hp structure  
       vu = p3 
-      
-      if(Re.le.0) then 
-      	dm = p2
-	D0 = gamma(vu)/gamma(vu+1)*dm
-      else
-	D0 = 2.0*Re*gamma(vu+2)/gamma(vu+3)
-      endif
-     
-      if (scaled .eqv. .false.) then
-      
+
+    else
+
+      ! vu isn't specified
+      
+      print *, 'Error: Must specify a value for vu for Modified Gamma distribution'
+      stop    
+      
+    endif
+      
+      if(Re>0) then
+
+    D0 = 2.0*Re*gamma(vu+2)/gamma(vu+3)
+   
         fc = ( &
              ((D*1E-6)**(vu-1)*exp(-1*D/D0)) / &
              (apm*((D0*1E-6)**(vu+bpm))*gamma(vu+bpm)) &
-	     ) * 1E-12
-	scaled = .true.
-
-      endif	   
-
-      N = fc*rho_a*(Q*1E-3)
-    
-    elseif (abs(p2+1) < 1E-8) then
-
-!     // N0, vu are given    
-      np = p1
-      vu = p3 
-      tmp1 = (Q*1E-3)**(1./bpm)
-      
-      if (scaled .eqv. .false.) then
-
-        fc = (D*1E-6 / (gamma(vu)/(apm*np*gamma(vu+bpm)))** &
+         ) * 1E-12
+
+        N = fc*rho_a*(Q*1E-3)
+        
+      elseif( p2+1 > 1E-8) then     ! use default value for MEAN diameter
+      
+        dm = p2
+    D0 = gamma(vu)/gamma(vu+1)*dm
+
+        fc = ( &
+             ((D*1E-6)**(vu-1)*exp(-1*D/D0)) / &
+             (apm*((D0*1E-6)**(vu+bpm))*gamma(vu+bpm)) &
+         ) * 1E-12
+
+        N = fc*rho_a*(Q*1E-3)
+        
+      elseif(abs(p3+1) > 1E-8)  then! use default number concentration
+    
+        local_np = p1 ! total number concentration / pa check
+   
+    tmp1 = (Q*1E-3)**(1./bpm)
+      
+        fc = (D*1E-6 / (gamma(vu)/(apm*local_np*gamma(vu+bpm)))** &
              (1./bpm))**vu
-	     
-        scaled = .true.
-
+         
+        N = ( &
+          (rho_a*local_np*fc*(D*1E-6)**(-1.))/(gamma(vu)*tmp1**vu) * &
+          exp(-1.*fc**(1./vu)/tmp1) &
+      ) * 1E-12
+
+      else
+      
+        print *, 'Error:  No default value for Dm or Np provided!  '
+        stop
+        
       endif
-
-      N = ( &
-          (rho_a*np*fc*(D*1E-6)**(-1.))/(gamma(vu)*tmp1**vu) * &
-          exp(-1.*fc**(1./vu)/tmp1) &
- 	  ) * 1E-12
-
-    else
-
-!     // vu isn't given
-      print *, 'Error: Must specify a value for vu'
-      stop
-    
-    endif
+    
     
 ! ---------------------------------------------------------!
@@ -152,57 +192,41 @@
 
   case(2)
-    if (abs(p1+1) > 1E-8) then
-
-!     // N0 has been specified, determine ld
-      N0 = p1
-
-      if(Re>0) then
-
-	! if Re is set and No is set than the distribution is fully defined.
-	! so we assume Re and No have already been chosen consistant with  
-	! the water content, Q.
-
-	! print *,'using Re pass ...'
-
-	ld = 1.5/Re   ! units 1/um
-
-	N = ( &
-          	N0*exp(-1*ld*D) &
-        ) * 1E-12
-    
-      else
-
-      	tmp1 = 1./(1.+bpm)
-      
-      	if (scaled .eqv. .false.) then
-        	fc = ((apm*gamma(1.+bpm)*N0)**tmp1)*(D*1E-6)
-		scaled = .true.
-
-      	endif
+ 
+    if(Re>0) then
+ 
+        ld = 1.5/Re   ! units 1/um
+        
+    fc = (ld*1E6)**(1.+bpm)/(apm*gamma(1+bpm))* &
+               exp(-1.*(ld*1E6)*(D*1E-6))*1E-12
      
-      	N = ( &
-        	N0*exp(-1.*fc*(1./(rho_a*Q*1E-3))**tmp1) &
-	) * 1E-12
-
-      endif	
+        N = fc*rho_a*(Q*1E-3)
+        
+    elseif (abs(p1+1) > 1E-8) then
+
+    ! use N0 default value
+    
+        N0 = p1
+
+        tmp1 = 1./(1.+bpm)
+  
+        fc = ((apm*gamma(1.+bpm)*N0)**tmp1)*(D*1E-6)
+  
+        N = ( &
+            N0*exp(-1.*fc*(1./(rho_a*Q*1E-3))**tmp1) &
+    ) * 1E-12
 
     elseif (abs(p2+1) > 1E-8) then
 
-!     // ld has been specified, determine N0
-      ld = p2
-
-      if (scaled .eqv. .false.) then
+    !     used default value for lambda 
+        ld = p2
 
         fc = (ld*1E6)**(1.+bpm)/(apm*gamma(1+bpm))* &
              exp(-1.*(ld*1E6)*(D*1E-6))*1E-12
-        scaled = .true.
-
-      endif
-
-      N = fc*rho_a*(Q*1E-3)
-
-    else
-
-!     // ld will be determined from temperature, then N0 follows
+     
+        N = fc*rho_a*(Q*1E-3)
+
+    else
+
+      !  ld "parameterized" from temperature (carry over from original Quickbeam).
       ld = 1220*10.**(-0.0245*tc)*1E-6
       N0 = ((ld*1E6)**(1+bpm)*Q*1E-3*rho_a)/(apm*gamma(1+bpm))
@@ -223,4 +247,14 @@
 
   case(3)
+  
+    if(Re>0) then
+        print *, 'Variable Re not supported for ', &
+         'Power-Law distribution'
+    stop
+    elseif(Np>0) then
+        print *, 'Variable Np not supported for ', &
+         'Power-Law distribution'
+    stop
+    endif
 
 !   :: br parameter
@@ -257,5 +291,5 @@
 
 !   :: commented lines are original method with constant density
-      ! rc = 500.		! (kg/m^3)
+      ! rc = 500.       ! (kg/m^3)
       ! tmp1 = 6*rho_a*(bhp+4)
       ! tmp2 = pi*rc*(dmax_mm**(bhp+4))*(1-(dmin_mm/dmax_mm)**(bhp+4))
@@ -273,11 +307,11 @@
       do k=lidx,uidx
  
-    	N(k) = ( &
+        N(k) = ( &
         ahp*(D(k)*1E-3)**bhp &
-	) * 1E-12    
+    ) * 1E-12    
 
       enddo
 
-	! print *,'test=',ahp,bhp,ahp/(rho_a*Q),D(100),N(100),bpm,dmin_mm,dmax_mm
+    ! print *,'test=',ahp,bhp,ahp/(rho_a*Q),D(100),N(100),bpm,dmin_mm,dmax_mm
 
 ! ---------------------------------------------------------!
@@ -288,14 +322,13 @@
   case(4)
   
-    if (scaled .eqv. .false.) then
-    
-      D0 = p1
+    if (Re>0) then
+        D0 = Re
+    else
+        D0 = p1
+    endif
+    
       rho_e = (6/pi)*apm*(D0*1E-6)**(bpm-3)
       fc(1) = (6./(pi*D0**3*rho_e))*1E12
-      scaled = .true.
-      
-    endif
-    
-    N(1) = fc(1)*rho_a*(Q*1E-3)
+      N(1) = fc(1)*rho_a*(Q*1E-3)
     
 ! ---------------------------------------------------------!
@@ -308,5 +341,5 @@
 
   case(5)
-    if (abs(p1+1) < 1E-8) then
+    if (abs(p1+1) < 1E-8 .or. Re>0 ) then
 
 !     // rg, log_sigma_g are given
@@ -314,28 +347,28 @@
       tmp2 = (bpm*log_sigma_g)**2.
       if(Re.le.0) then 
-      	rg = p2
-      else
-	rg =Re*exp(-2.5*(log_sigma_g**2))
+        rg = p2
+      else
+    rg =Re*exp(-2.5*(log_sigma_g**2))
       endif
  
-      if (scaled .eqv. .false.) then
-            
-        fc = 0.5 * ( &
-	     (1./((2.*rg*1E-6)**(bpm)*apm*(2.*pi)**(0.5) * &
-	     log_sigma_g*D*0.5*1E-6)) * &
-	     exp(-0.5*((log(0.5*D/rg)/log_sigma_g)**2.+tmp2)) &
-	     ) * 1E-12
-	scaled = .true.
-	     
+         fc = 0.5 * ( &
+         (1./((2.*rg*1E-6)**(bpm)*apm*(2.*pi)**(0.5) * &
+         log_sigma_g*D*0.5*1E-6)) * &
+         exp(-0.5*((log(0.5*D/rg)/log_sigma_g)**2.+tmp2)) &
+         ) * 1E-12
+                
+      N = fc*rho_a*(Q*1E-3)
+      
+    elseif (abs(p2+1) < 1E-8 .or. Np>0) then
+
+!     // Np, log_sigma_g are given    
+      if(Np>0) then
+        local_Np=Np
+      else
+        local_Np = p1
       endif
-	        
-      N = fc*rho_a*(Q*1E-3)
-      
-    elseif (abs(p2+1) < 1E-8) then
-
-!     // N0, log_sigma_g are given    
-      Np = p1
+      
       log_sigma_g = p3
-      N0 = np*rho_a
+      N0 = local_np*rho_a
       tmp1 = (rho_a*(Q*1E-3))/(2.**bpm*apm*N0)
       tmp2 = exp(0.5*bpm**2.*(log_sigma_g))**2.      
@@ -344,10 +377,9 @@
       N = 0.5*( &
         N0 / ((2.*pi)**(0.5)*log_sigma_g*D*0.5*1E-6) * &
-	exp((-0.5*(log(0.5*D/rg)/log_sigma_g)**2.)) &
-	) * 1E-12      
-      
-    else
-
-!     // vu isn't given
+    exp((-0.5*(log(0.5*D/rg)/log_sigma_g)**2.)) &
+    ) * 1E-12      
+      
+    else
+
       print *, 'Error: Must specify a value for sigma_g'
       stop
Index: LMDZ5/trunk/libf/phylmd/cosp/format_input.F90
===================================================================
--- LMDZ5/trunk/libf/phylmd/cosp/format_input.F90	(revision 2367)
+++ LMDZ5/trunk/libf/phylmd/cosp/format_input.F90	(revision 2428)
@@ -1,2 +1,4 @@
+! $Revision: 23 $, $Date: 2011-03-31 15:41:37 +0200 (jeu. 31 mars 2011) $
+! $URL: http://cfmip-obs-sim.googlecode.com/svn/stable/v1.4.0/quickbeam/format_input.f90 $
 ! FORMAT_INPUT: Procedures to prepare data for input to the simulator
 ! Compiled/Modified:
Index: LMDZ5/trunk/libf/phylmd/cosp/gases.F90
===================================================================
--- LMDZ5/trunk/libf/phylmd/cosp/gases.F90	(revision 2367)
+++ LMDZ5/trunk/libf/phylmd/cosp/gases.F90	(revision 2428)
@@ -1,2 +1,4 @@
+! $Revision: 88 $, $Date: 2013-11-13 15:08:38 +0100 (mer. 13 nov. 2013) $
+! $URL: http://cfmip-obs-sim.googlecode.com/svn/stable/v1.4.0/quickbeam/gases.f90 $
   function gases(PRES_mb,T,RH,f)
   implicit none
@@ -30,4 +32,7 @@
   real*8, dimension(nbands_o2) :: v0, a1, a2, a3, a4, a5, a6
   real*8, dimension(nbands_h2o) :: v1, b1, b2, b3
+  real*8 :: e_th,one_th,pth3,eth35,aux1,aux2,aux3,aux4
+  real*8 :: gm,delt,x,y,gm2
+  real*8 :: fpp_o2,fpp_h2o,s_o2,s_h2o
   integer :: i
   
@@ -110,13 +115,27 @@
   
 ! // conversions
-  th = 300./T		! unitless
-  e = (RH*th**5)/(41.45*10**(9.834*th-10))	! kPa
-  p = PRES_mb/10.-e	! kPa
+  th = 300./T       ! unitless
+  e = (RH*th**5)/(41.45*10**(9.834*th-10))   ! kPa
+  p = PRES_mb/10.-e ! kPa
+  e_th = e*th
+  one_th = 1 - th
+  pth3 = p*th**(3)
+  eth35 = e*th**(3.5)
 
 ! // term1
   sumo = 0.
+  aux1 = 1.1*e_th
   do i=1,nbands_o2
-    sumo = sumo + fpp_o2(p,th,e,a3(i),a4(i),a5(i),a6(i),f,v0(i)) &
-           * s_o2(p,th,a1(i),a2(i))
+    aux2 = f/v0(i)
+    aux3 = v0(i)-f
+    aux4 = v0(i)+f
+    gm = a3(i)*(p*th**(0.8-a4(i))+aux1)
+    gm2 = gm**2
+    delt = a5(i)*p*th**a6(i)
+    x = aux3**2+gm2
+    y = aux4**2+gm2
+    fpp_o2 = (((1./x)+(1./y))*(gm*aux2) - (delt*aux2)*((aux3/(x))-(aux4/(x))))
+    s_o2 = a1(i)*pth3*exp(a2(i)*one_th)
+    sumo = sumo + fpp_o2 * s_o2
   enddo
   term1 = sumo
@@ -131,7 +150,17 @@
 ! // term3
   sumo = 0.
+  aux1 = 4.8*e_th
   do i=1,nbands_h2o
-    sumo = sumo + fpp_h2o(p,th,e,b3(i),f,v1(i)) &
-           * s_h2o(th,e,b1(i),b2(i))
+    aux2 = f/v1(i)
+    aux3 = v1(i)-f
+    aux4 = v1(i)+f
+    gm = b3(i)*(p*th**(0.8)+aux1)
+    gm2 = gm**2
+    x = aux3**2+gm2
+    y = aux4**2+gm2
+    !delt = 0.
+    fpp_h2o = ((1./x)+(1./y))*(gm*aux2) ! - (delt*aux2)*((aux3/(x))-(aux4/(x)))
+    s_h2o = b1(i)*eth35*exp(b2(i)*one_th)
+    sumo = sumo + fpp_h2o * s_h2o
   enddo
   term3 = sumo
@@ -146,37 +175,3 @@
   gases = 0.182*f*npp
 
-! ----- SUB FUNCTIONS -----
-    
-  contains
-  
-  function fpp_o2(p,th,e,a3,a4,a5,a6,f,v0)
-  real*8 :: fpp_o2,p,th,e,a3,a4,a5,a6,f,v0
-  real*8 :: gm, delt, x, y
-  gm = a3*(p*th**(0.8-a4)+1.1*e*th)
-  delt = a5*p*th**(a6)
-  x = (v0-f)**2+gm**2
-  y = (v0+f)**2+gm**2
-  fpp_o2 = ((1./x)+(1./y))*(gm*f/v0) - (delt*f/v0)*(((v0-f)/(x))-((v0+f)/(x)))  
-  end function fpp_o2
-  
-  function fpp_h2o(p,th,e,b3,f,v0)
-  real*8 :: fpp_h2o,p,th,e,b3,f,v0
-  real*8 :: gm, delt, x, y
-  gm = b3*(p*th**(0.8)+4.8*e*th)
-  delt = 0.
-  x = (v0-f)**2+gm**2
-  y = (v0+f)**2+gm**2
-  fpp_h2o = ((1./x)+(1./y))*(gm*f/v0) - (delt*f/v0)*(((v0-f)/(x))-((v0+f)/(x)))
-  end function fpp_h2o
-  
-  function s_o2(p,th,a1,a2)
-  real*8 :: s_o2,p,th,a1,a2
-  s_o2 = a1*p*th**(3)*exp(a2*(1-th))
-  end function s_o2
-
-  function s_h2o(th,e,b1,b2)
-  real*8 :: s_h2o,th,e,b1,b2
-  s_h2o = b1*e*th**(3.5)*exp(b2*(1-th))
-  end function s_h2o
-  
   end function gases
Index: LMDZ5/trunk/libf/phylmd/cosp/icarus.F
===================================================================
--- LMDZ5/trunk/libf/phylmd/cosp/icarus.F	(revision 2367)
+++ LMDZ5/trunk/libf/phylmd/cosp/icarus.F	(revision 2428)
@@ -1,2 +1,4 @@
+! $Revision: 88 $, $Date: 2013-11-13 15:08:38 +0100 (mer. 13 nov. 2013) $
+! $URL: http://cfmip-obs-sim.googlecode.com/svn/stable/v1.4.0/icarus-scops-4.1-bsd/icarus.f $
       SUBROUTINE ICARUS(
      &     debug,
